package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import java.util.stream.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class OFCB001_OUT_REC {
    public @Getter @Builder.Default String OUT_CUSTOMER_NUMBER = StringUtils
            .repeat(' ', 6);
    public @Getter @Builder.Default String OUT_FIRST_NAME = StringUtils.repeat(
            ' ', 20);
    public @Getter @Builder.Default String OUT_LAST_NAME = StringUtils.repeat(
            ' ', 30);
    public @Getter @Setter int OUT_LAST_UPDATE;
    private final static BiFunction<Long, String, String> intFormatWithoutSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.setNegativePrefix("");
        nf.applyPattern(format);
        return nf.format(value);
    };

    public void setOUT_CUSTOMER_NUMBER(String source) {
        OUT_CUSTOMER_NUMBER = StringUtils.truncate(
                StringUtils.rightPad(source, 6), 6);
    }

    public void setOUT_FIRST_NAME(String source) {
        OUT_FIRST_NAME = StringUtils.truncate(StringUtils.rightPad(source, 20),
                20);
    }

    public void setOUT_LAST_NAME(String source) {
        OUT_LAST_NAME = StringUtils.truncate(StringUtils.rightPad(source, 30),
                30);
    }

    public String getStringOUT_LAST_UPDATE() {
        return intFormatWithoutSign.apply((long) OUT_LAST_UPDATE, "00000000");
    }

    public static OFCB001_OUT_REC createDefaultValueInstance() {
        return new OFCB001_OUT_REC.builder().build();
    }

    @Override
    public String toString() {
        return getOUT_CUSTOMER_NUMBER() + getOUT_FIRST_NAME()
                + getOUT_LAST_NAME() + getStringOUT_LAST_UPDATE();
    }
}
